package org.capcaval.ermine.jfx;

import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;
import java.util.Properties;
import java.util.Set;

import org.capcaval.ermine.coves.AbstractCovesApplication;
import org.capcaval.ermine.coves.Controller;
import org.capcaval.ermine.coves._test.AppController;
import org.capcaval.lafabrique.application.ApplicationTools;
import org.capcaval.lafabrique.common.CommandResult;
import org.capcaval.lafabrique.converter.Converter;
import org.capcaval.lafabrique.file.FileTools;

public class JfxApplicationTools {

	public static CommandResult runApplication(Class<? extends AbstractCovesApplication> applicationType, String... args) {
		return runApplication(applicationType, args, (Converter<?,?>[])null);
	}
	
	public static CommandResult runApplication(final Class<? extends AbstractCovesApplication> applicationType, final String[] args, final Converter<?,?>... converterList) {
		// firstly start JavaFX
		JfxApplication.start();
		
		final CommandResult cr = new CommandResult();
		
		// secondly run user application
		//Platform.runLater(new Runnable() {
		JfxTools.invokeAndWait(new Runnable() {
			@Override
			public void run() {
				// allocate the application
				AbstractCovesApplication application = null;
				try {
					application =applicationType.newInstance();
					
					JfxFrame.factory.setApp(application);
					
//					// check out if property file exist
//					if(FileTools.isFileExist("language.properties") == true){
//						
//						//application.applyLanguage(application.)
//						Properties prop = new Properties();
//						FileInputStream file = new FileInputStream("language.properties");
//						 
//						// load a properties file
//						prop.load(file);
//						
//						Set<Entry<Object, Object>> set = prop.entrySet();
//						
//						for(Entry<Object, Object> entry : set){
//							String gadgetKey = (String)entry.getKey();
//							String gadgetValue = (String)entry.getKey();
//							
//							
//						}
//					}					
				} catch (Exception e) {
					e.printStackTrace();
				}
				cr.concat(ApplicationTools.runApplication(applicationType, application, args, converterList));
			}
		});
		
		return cr;
	}

	public static Class<? extends Controller<?>>[] getAllAppController(Class<?> applicationType) {
		List<Class<?>> controllerTypeList = new ArrayList<>();
		
		for(Field field :applicationType.getDeclaredFields()){
			field.setAccessible(true);
			AppController appCtrl = field.getAnnotation(AppController.class);
			if(appCtrl != null){
				// get it
				controllerTypeList.add(field.getType());
			}
		}
		
		return (Class<? extends Controller<?>>[])controllerTypeList.toArray(new Class<?>[0]);
	}
	
}
