package org.capcaval.ermine.jfx.node;

import javafx.collections.ObservableList;
import javafx.scene.control.ComboBox;

public class JfxEnumComboBox extends ComboBox<Enum<?>> {

	public JfxEnumComboBox() {
	}

	public JfxEnumComboBox(Class<Enum<?>> enumType) {
		this.setEnumType(enumType);
	}

	public void setEnumType(Class<? extends Enum<?>> enumType) {
		// get the current item list
		ObservableList<Enum<?>> list = this.getItems();
		// clean if needed
		list.clear();
		// get the new values
		Enum<?>[] constantArray = enumType.getEnumConstants();
		// add them
		list.addAll(constantArray);
	}
}
