package org.capcaval.ermine.layout;


public class NodeWrapper <T>{
	
	enum LayoutTypeEnum{ onePoint, twoPoints, onlyWidth, onlyHeight}
	
	RefPoint<T> point1;
	RefPoint<T> point2;
	LayoutTypeEnum type;
	
	
	public NodeWrapper(T node, RefPointEnum refPoint, int deltaX, int deltaY) {
		// this is a one point ref
		this.point1 = new RefPoint<T>(node, refPoint, deltaX, deltaY);
		this.point2 = null;
		this.type = LayoutTypeEnum.onePoint;  
	}

	public NodeWrapper(T node, 
			RefPointEnum tlRefpoint, int tlDeltaX, int tlDeltaY, 
			RefPointEnum brRefpoint, int brDeltaX, int brDeltaY) {
		this.point1 = new RefPoint<T>(node, tlRefpoint, tlDeltaX, tlDeltaY);
		this.point2 = new RefPoint<T>(node, brRefpoint, brDeltaX, brDeltaY);
		this.type = LayoutTypeEnum.twoPoints;
	}

	public RefPoint<T> getPoint1() {
		return this.point1;
	}
	
	public RefPoint<T> getPoint2() {
		return this.point2;
	}
	
	public LayoutTypeEnum getType(){
		return this.type;
	}
}
